Index: trunk/NEMO/OPA_SRC/FLO/flowri.F90
===================================================================
--- trunk/NEMO/OPA_SRC/FLO/flowri.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/FLO/flowri.F90	(revision 16)
@@ -15,4 +15,5 @@
    USE dom_oce         ! ocean space and time domain
    USE lib_mpp         ! distribued memory computing library
+   USE daymod
    USE in_out_manager  ! I/O manager
 
@@ -52,4 +53,5 @@
 
       !! * Local declarations
+      CHARACTER (len=21) ::  clname
       INTEGER ::   inum = 11       ! temporary logical unit for restart file
       INTEGER  ::   &
@@ -62,7 +64,5 @@
       REAL(wp) :: zafl,zbfl,zcfl,zdtj
       REAL(wp) :: zxxu, zxxu_01,zxxu_10, zxxu_11
-      REAL(wp) , DIMENSION ( jpk  , jpnfl) :: ztemp, zsal
-
-      CHARACTER (len=21) ::  clname
+      REAL(wp), DIMENSION (jpk,jpnfl) :: ztemp, zsal
       !!---------------------------------------------------------------------
       
@@ -86,28 +86,75 @@
             IF(lwp) WRITE(numflo)cexper,no,irecflo,jpnfl,nwritefl
          ENDIF
-         zdtj = rdt/86400.      
+         zdtj = rdt / 86400.      !!bug   use of 86400 instead of the phycst parameter
 
          ! translation of index position in geographical position
 
-         DO jfl = 1, jpnfl
-            iafl  = INT (tpifl(jfl))
-            ibfl  = INT (tpjfl(jfl))
-            icfl  = INT (tpkfl(jfl))
-            iafln = NINT(tpifl(jfl))
-            ibfln = NINT(tpjfl(jfl))
-            ia1fl = iafl+1
-            ib1fl = ibfl+1
-            ic1fl = icfl+1
-            zafl  = tpifl(jfl) - FLOAT(iafl)
-            zbfl  = tpjfl(jfl) - FLOAT(ibfl)
-            zcfl  = tpkfl(jfl) - FLOAT(icfl)
-# if defined key_mpp
-            IF( (iafl >= (mig(nldi)-jpizoom+1)) .AND. (iafl <= (mig(nlei)-jpizoom+1)) .AND.   &
-              (  ibfl >= (mjg(nldj)-jpjzoom+1)) .AND. (ibfl <= (mjg(nlej)-jpjzoom+1)) ) THEN
-
-               ! local index
-
-               iafloc  = iafl -(mig(1)-jpizoom+1) + 1
-               ibfloc  = ibfl -(mjg(1)-jpjzoom+1) + 1
+         IF( lk_mpp ) THEN
+            DO jfl = 1, jpnfl
+               iafl  = INT ( tpifl(jfl) )
+               ibfl  = INT ( tpjfl(jfl) )
+               icfl  = INT ( tpkfl(jfl) )
+               iafln = NINT( tpifl(jfl) )
+               ibfln = NINT( tpjfl(jfl) )
+               ia1fl = iafl + 1
+               ib1fl = ibfl + 1
+               ic1fl = icfl + 1
+               zafl  = tpifl(jfl) - FLOAT( iafl )
+               zbfl  = tpjfl(jfl) - FLOAT( ibfl )
+               zcfl  = tpkfl(jfl) - FLOAT( icfl )
+               IF(   iafl >= mig(nldi)-jpizoom+1 .AND. iafl <= mig(nlei)-jpizoom+1 .AND.   &
+                  &  ibfl >= mjg(nldj)-jpjzoom+1 .AND. ibfl <= mjg(nlej)-jpjzoom+1       ) THEN
+
+                  ! local index
+
+                  iafloc  = iafl -(mig(1)-jpizoom+1) + 1
+                  ibfloc  = ibfl -(mjg(1)-jpjzoom+1) + 1
+                  ia1floc = iafloc + 1
+                  ib1floc = ibfloc + 1
+
+                  flyy(jfl) = (1.-zafl)*(1.-zbfl)*gphit(iafloc ,ibfloc ) + (1.-zafl) * zbfl * gphit(iafloc ,ib1floc)   &
+                     &      +     zafl *(1.-zbfl)*gphit(ia1floc,ibfloc ) +     zafl  * zbfl * gphit(ia1floc,ib1floc)
+                  flxx(jfl) = (1.-zafl)*(1.-zbfl)*glamt(iafloc ,ibfloc ) + (1.-zafl) * zbfl * glamt(iafloc ,ib1floc)   &
+                     &      +     zafl *(1.-zbfl)*glamt(ia1floc,ibfloc ) +     zafl  * zbfl * glamt(ia1floc,ib1floc)
+                  flzz(jfl) = (1.-zcfl)*fsdepw(iafloc,ibfloc,icfl ) + zcfl * fsdepw(iafloc,ibfloc,ic1fl)
+
+                  ! Change  by Alexandra Bozec et Jean-Philippe Boulanger
+                  ! We save  the instantaneous profile of T and S of the column     
+                  ! ztemp(jfl)=tn(iafloc,ibfloc,icfl)
+                  ! zsal(jfl)=sn(iafloc,ibfloc,icfl)
+                  ztemp(1:jpk,jfl) = tn(iafloc,ibfloc,1:jpk)
+                  zsal (1:jpk,jfl) = sn(iafloc,ibfloc,1:jpk)            
+               ELSE
+                  flxx(jfl) = 0.
+                  flyy(jfl) = 0.
+                  flzz(jfl) = 0.
+                  ztemp(1:jpk,jfl) = 0.
+                  zsal (1:jpk,jfl) = 0.
+               ENDIF
+            END DO
+
+            CALL mpp_sum( flxx, jpnfl )   ! sums over the global domain
+            CALL mpp_sum( flyy, jpnfl )
+            CALL mpp_sum( flzz, jpnfl )
+            ! these 2 lines have accendentaly been removed from ATL6-V8 run hence
+            ! giving 0 salinity and temperature on the float trajectory
+            CALL mpp_sum( ztemp, jpk*jpnfl )
+            CALL mpp_sum( zsal , jpk*jpnfl )
+
+         ELSE
+            DO jfl = 1, jpnfl
+               iafl  = INT (tpifl(jfl))
+               ibfl  = INT (tpjfl(jfl))
+               icfl  = INT (tpkfl(jfl))
+               iafln = NINT(tpifl(jfl))
+               ibfln = NINT(tpjfl(jfl))
+               ia1fl = iafl+1
+               ib1fl = ibfl+1
+               ic1fl = icfl+1
+               zafl  = tpifl(jfl) - FLOAT(iafl)
+               zbfl  = tpjfl(jfl) - FLOAT(ibfl)
+               zcfl  = tpkfl(jfl) - FLOAT(icfl)
+               iafloc  = iafl
+               ibfloc  = ibfl
                ia1floc = iafloc + 1
                ib1floc = ibfloc + 1
@@ -118,60 +165,25 @@
                          +     zafl *(1.-zbfl)*glamt(ia1floc,ibfloc ) +     zafl  * zbfl * glamt(ia1floc,ib1floc)
                flzz(jfl) = (1.-zcfl)*fsdepw(iafloc,ibfloc,icfl ) + zcfl * fsdepw(iafloc,ibfloc,ic1fl)
-
+               !ALEX
+               ! Astuce pour ne pas avoir des flotteurs qui se baladent sur IDL
+               zxxu_11 = glamt(iafloc ,ibfloc )
+               zxxu_10 = glamt(iafloc ,ib1floc)
+               zxxu_01 = glamt(ia1floc,ibfloc )
+               zxxu    = glamt(ia1floc,ib1floc)
+
+               IF( iafloc == 52 )  zxxu_10 = -181
+               IF( iafloc == 52 )  zxxu_11 = -181
+               flxx(jfl)=(1.-zafl)*(1.-zbfl)* zxxu_11 + (1.-zafl)*    zbfl * zxxu_10   &
+                        +    zafl *(1.-zbfl)* zxxu_01 +     zafl *    zbfl * zxxu
+               !ALEX         
                ! Change  by Alexandra Bozec et Jean-Philippe Boulanger
                ! We save  the instantaneous profile of T and S of the column     
-               ! ztemp(jfl)=tn(iafloc,ibfloc,icfl)
-               ! zsal(jfl)=sn(iafloc,ibfloc,icfl)
+               !     ztemp(jfl)=tn(iafloc,ibfloc,icfl)
+               !     zsal(jfl)=sn(iafloc,ibfloc,icfl)
                ztemp(1:jpk,jfl) = tn(iafloc,ibfloc,1:jpk)
-               zsal (1:jpk,jfl) = sn(iafloc,ibfloc,1:jpk)            
-            ELSE
-               flxx(jfl) = 0.
-               flyy(jfl) = 0.
-               flzz(jfl) = 0.
-               ztemp(1:jpk,jfl) = 0.
-               zsal (1:jpk,jfl) = 0.
-            ENDIF
-# else
-            iafloc  = iafl
-            ibfloc  = ibfl
-            ia1floc = iafloc + 1
-            ib1floc = ibfloc + 1
-            !
-            flyy(jfl) = (1.-zafl)*(1.-zbfl)*gphit(iafloc ,ibfloc ) + (1.-zafl) * zbfl * gphit(iafloc ,ib1floc)   &
-                      +     zafl *(1.-zbfl)*gphit(ia1floc,ibfloc ) +     zafl  * zbfl * gphit(ia1floc,ib1floc)
-            flxx(jfl) = (1.-zafl)*(1.-zbfl)*glamt(iafloc ,ibfloc ) + (1.-zafl) * zbfl * glamt(iafloc ,ib1floc)   &
-                      +     zafl *(1.-zbfl)*glamt(ia1floc,ibfloc ) +     zafl  * zbfl * glamt(ia1floc,ib1floc)
-            flzz(jfl) = (1.-zcfl)*fsdepw(iafloc,ibfloc,icfl ) + zcfl * fsdepw(iafloc,ibfloc,ic1fl)
-            !ALEX
-            ! Astuce pour ne pas avoir des flotteurs qui se baladent sur IDL
-            zxxu_11 = glamt(iafloc ,ibfloc )
-            zxxu_10 = glamt(iafloc ,ib1floc)
-            zxxu_01 = glamt(ia1floc,ibfloc )
-            zxxu    = glamt(ia1floc,ib1floc)
-
-            IF( iafloc == 52 )  zxxu_10 = -181
-            IF( iafloc == 52 )  zxxu_11 = -181
-            flxx(jfl)=(1.-zafl)*(1.-zbfl)* zxxu_11 + (1.-zafl)*    zbfl * zxxu_10   &
-                     +    zafl *(1.-zbfl)* zxxu_01 +     zafl *    zbfl * zxxu
-            !ALEX         
-            ! Change  by Alexandra Bozec et Jean-Philippe Boulanger
-            ! We save  the instantaneous profile of T and S of the column     
-            !     ztemp(jfl)=tn(iafloc,ibfloc,icfl)
-            !     zsal(jfl)=sn(iafloc,ibfloc,icfl)
-            ztemp(1:jpk,jfl) = tn(iafloc,ibfloc,1:jpk)
-            zsal (1:jpk,jfl) = sn(iafloc,ibfloc,1:jpk)
-# endif
-         END DO
-
-# if defined key_mpp
-         CALL mpp_sum( flxx, jpnfl )
-         CALL mpp_sum( flyy, jpnfl )
-         CALL mpp_sum( flzz, jpnfl )
-         ! these 2 lines have accendentaly been removed from ATL6-V8 run hence
-         ! giving 0 salinity and temperature on the float trajectory
-         CALL mpp_sum( ztemp, jpk*jpnfl )
-         CALL mpp_sum( zsal , jpk*jpnfl )
-
-# endif
+               zsal (1:jpk,jfl) = sn(iafloc,ibfloc,1:jpk)
+            END DO
+         ENDIF
+
          !
          WRITE(numflo) flxx,flyy,flzz,nisobfl,ngrpfl,ztemp,zsal, FLOAT(ndastp)
@@ -187,5 +199,5 @@
       !         iafln=NINT(tpifl(jfl))
       !         ibfln=NINT(tpjfl(jfl))
-      !# if defined key_mpp
+      !# if defined key_mpp_mpi   ||   defined key_mpp_shmem
       !        IF ( (iafl >= (mig(nldi)-jpizoom+1)) .AND.
       !     $       (iafl <= (mig(nlei)-jpizoom+1)) .AND.
@@ -206,5 +218,5 @@
       !         ztemp(jfl)=tn(iafloc,ibfloc,jk)
       !         zsal(jfl)=sn(iaflo!,ibfloc,jk)
-      !# if defined key_mpp
+      !# if defined key_mpp_mpi   ||   defined key_mpp_shmem
       !        ELSE
       !         ztemp(jfl) = 0.
@@ -214,8 +226,7 @@
       !! ... next float
       !        END DO
-      !#if defined key_mpp
-      !      CALL mpp_sum( ztemp, jpnfl )
-      !      CALL mpp_sum( zsal , jpnfl )
-      !# endif
+      !      IF( lk_mpp )   CALL mpp_sum( ztemp, jpnfl )
+      !      IF( lk_mpp )   CALL mpp_sum( zsal , jpnfl )
+      !
       !      IF (lwp) THEN 
       !         WRITE(numflo) ztemp, zsal
@@ -268,24 +279,24 @@
          ! Compute the number of trajectories for each processor
          !
-# if defined key_mpp
-         DO jfl = 1, jpnfl
-            IF( (INT(tpifl(jfl)) >= (mig(nldi)-jpizoom+1)) .AND.   &
-              (  INT(tpifl(jfl)) <= (mig(nlei)-jpizoom+1)) .AND.   &
-              (  INT(tpjfl(jfl)) >= (mjg(nldj)-jpjzoom+1)) .AND.   &
-              (  INT(tpjfl(jfl)) <= (mjg(nlej)-jpjzoom+1)) ) THEN
-               iproc(narea) = iproc(narea)+1
-            ENDIF
-         END DO
-         CALL mpp_sum( iproc, jpnij )
-         !
-         IF(lwp) THEN 
-            WRITE(numout,*) 'DATE',adatrj
-            DO jpn = 1, jpnij
-               IF( iproc(jpn) /= 0 ) THEN
-                  WRITE(numout,*)'PROCESSOR',jpn-1,'compute',iproc(jpn), 'trajectories.'
+         IF( lk_mpp ) THEN
+            DO jfl = 1, jpnfl
+               IF( (INT(tpifl(jfl)) >= (mig(nldi)-jpizoom+1)) .AND.   &
+                  &(INT(tpifl(jfl)) <= (mig(nlei)-jpizoom+1)) .AND.   &
+                  &(INT(tpjfl(jfl)) >= (mjg(nldj)-jpjzoom+1)) .AND.   &
+                  &(INT(tpjfl(jfl)) <= (mjg(nlej)-jpjzoom+1)) ) THEN
+                  iproc(narea) = iproc(narea)+1
                ENDIF
             END DO
-         ENDIF
-# endif
+            CALL mpp_sum( iproc, jpnij )
+            !
+            IF(lwp) THEN 
+               WRITE(numout,*) 'DATE',adatrj
+               DO jpn = 1, jpnij
+                  IF( iproc(jpn) /= 0 ) THEN
+                     WRITE(numout,*)'PROCESSOR',jpn-1,'compute',iproc(jpn), 'trajectories.'
+                  ENDIF
+               END DO
+            ENDIF
+         ENDIF
       ENDIF 
 
Index: trunk/NEMO/OPA_SRC/SOL/sol_oce.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SOL/sol_oce.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/SOL/sol_oce.F90	(revision 16)
@@ -16,43 +16,48 @@
 
    IMPLICIT NONE
+   PRIVATE
 
-   !!----------------------------------------------------------------------
+   !!-----------------------------------
    !! elliptic solver: SOR, PCG or FETI
-   !! ---------------------------------------------------
-   INTEGER  ::              & !!! namsol   elliptic solver / island / free surface
-      nsolv =    1 ,        &  ! = 1/2/3 type of elliptic solver
-      nmax  =  800 ,        &  ! maximum of iterations for the solver
-      nmisl = 4000             ! maximum pcg iterations for island
+   !! ----------------------------------
+   INTEGER , PUBLIC ::      & !!: namsol   elliptic solver / island / free surface
+      nsolv =    1 ,        &  !: = 1/2/3 type of elliptic solver
+      nmax  =  800 ,        &  !: maximum of iterations for the solver
+      nmisl = 4000             !: maximum pcg iterations for island
      
-   REAL(wp) ::              & !!! namsol   elliptic solver / island / free surface
-      eps    = 1.e-6_wp ,   &  ! absolute precision of the solver
-      sor    = 1.76_wp  ,   &  ! optimal coefficient for sor solver
-      epsisl = 1.e-10_wp,   &  ! absolute precision on stream function solver
-      rnu    = 1.0_wp          ! strength of the additional force used in free surface
+   REAL(wp), PUBLIC ::      & !!: namsol   elliptic solver / island / free surface
+      eps    = 1.e-6_wp ,   &  !: absolute precision of the solver
+      sor    = 1.76_wp  ,   &  !: optimal coefficient for sor solver
+      epsisl = 1.e-10_wp,   &  !: absolute precision on stream function solver
+      rnu    = 1.0_wp          !: strength of the additional force used in free surface
 
-   INTEGER  ::   &
-      ncut,         &  ! indicator of solver convergence
-      niter            ! number of iteration done by the solver
+   CHARACTER(len=1), PUBLIC ::   &  !:
+      c_solver_pt = 'T'        !: nature of grid-points T (S) for free surface case
+      !                        !                       F (G) for rigid-lid case
 
-   REAL(wp) ::   &
-      epsr,         &  ! relative precision for SOR & PCG solvers
-      epsilo,       &  ! precision for the FETI solver
-      rnorme, res,  &  ! intermediate modulus, solver residu
-      alph,         &  ! coefficient  =(gcr,gcr)/(gcx,gccd)
-      beta,         &  ! coefficient  =(rn+1,rn+1)/(rn,rn)
-      radd,         &  ! coefficient  =(gccd,gcdes)
-      rr               ! coefficient  =(rn,rn)
+   INTEGER , PUBLIC ::   &  !:
+      ncut,         &  !: indicator of solver convergence
+      niter            !: number of iteration done by the solver
 
-   REAL(wp), DIMENSION(jpi,jpj,4) ::   &
-      gcp              ! barotropic matrix extra-diagonal elements
+   REAL(wp), PUBLIC ::   &  !:
+      epsr,         &  !: relative precision for SOR & PCG solvers
+      epsilo,       &  !: precision for the FETI solver
+      rnorme, res,  &  !: intermediate modulus, solver residu
+      alph,         &  !: coefficient  =(gcr,gcr)/(gcx,gccd)
+      beta,         &  !: coefficient  =(rn+1,rn+1)/(rn,rn)
+      radd,         &  !: coefficient  =(gccd,gcdes)
+      rr               !: coefficient  =(rn,rn)
 
-   REAL(wp), DIMENSION(jpi,jpj) ::   &
-      gcx, gcxb,    &  ! now, before solution of the elliptic equation
-      gcdprc,       &  ! inverse diagonal preconditioning matrix
-      gcdmat,       &  ! diagonal preconditioning matrix
-      gcb,          &  ! second member of the barotropic linear system
-      gcr,          &  ! residu =b-a.x
-      gcdes,        &  ! vector descente
-      gccd             ! vector such that ca.gccd=a.d (ca-1=gcdprc)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,4) ::   &  !:
+      gcp              !: barotropic matrix extra-diagonal elements
+
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &  !:
+      gcx, gcxb,    &  !: now, before solution of the elliptic equation
+      gcdprc,       &  !: inverse diagonal preconditioning matrix
+      gcdmat,       &  !: diagonal preconditioning matrix
+      gcb,          &  !: second member of the barotropic linear system
+      gcr,          &  !: residu =b-a.x
+      gcdes,        &  !: vector descente
+      gccd             !: vector such that ca.gccd=a.d (ca-1=gcdprc)
 
 #if defined key_feti
@@ -67,5 +72,5 @@
    !!      malistin()       : concatened list of interface nodes
 
-   INTEGER :: nim,nxm,   &
+   INTEGER, PUBLIC :: nim,nxm,   &
        malxm,malim,malxmax,malimax,   &
        nifmat,njfmat,nelem,npe,matopo,   &
@@ -85,7 +90,8 @@
        madwork
 
-   INTEGER :: mfet(jpi*jpj+2*jpi+2*jpj+51)
+   INTEGER, PUBLIC :: mfet(jpi*jpj+2*jpi+2*jpj+51)
 
-   REAL(wp) ::  wfeti(jpj*jpi*jpi+13*jpi*jpj+19*(jpi+jpj)   &
+   REAL(wp), PUBLIC ::   &  !:
+      wfeti(jpj*jpi*jpi+13*jpi*jpj+19*(jpi+jpj)   &
        +4*jpnij+33   &
        +2*(jpi+jpj)*(jpnij-jpni)*jpi   &
@@ -94,5 +100,5 @@
        +3*(jpnij-jpnj+jperio)*jpj) 
 
-   REAL(wp) ::   res2, rcompt
+   REAL(wp), PUBLIC ::   res2, rcompt
 
 #endif
Index: trunk/NEMO/OPA_SRC/SOL/solfet.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SOL/solfet.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/SOL/solfet.F90	(revision 16)
@@ -33,5 +33,5 @@
       !!     Solve the ellipic equation for the barotropic stream function
       !!     system (default option) or the transport divergence system
-      !!     ("key_dynspg_fsc") using a Finite Elements Tearing & 
+      !!     (lk_dynspg_fsc=T) using a Finite Elements Tearing and 
       !!      Interconnecting (FETI) approach.
       !!     In the former case, the barotropic stream function trend has a
@@ -142,26 +142,5 @@
       CALL feti_vmov( noeuds, wfeti(miax), gcx )
 
-      ! boundary conditions   !!bug ???  check  arguments...
-#   if defined key_dynspg_fsc
-#      if defined key_mpp
-      !   Mpp: export boundary values to neighbouring processors
-      CALL lbc_lnk( gcx, 'S', 1. )
-#      else
-      !   mono- or macro-tasking: W-point, >0, 2D array, no slab
-      IF( nperio /= 0 ) THEN
-         CALL lbc_lnk( gcx, 'T', 1. )
-      ENDIF
-#      endif
-#   else
-#      if defined key_mpp
-      !   Mpp: export boundary values to neighbouring processors
-      CALL lbc_lnk( gcx, 'G', 1. )
-#      else
-      !   mono- or macro-tasking: W-point, >0, 2D array, no slab
-      IF( nperio /= 0 ) THEN
-         CALL lbc_lnk( gcx, 'F', 1. )
-      ENDIF
-#      endif
-#   endif
+      CALL lbc_lnk( gcx, c_solver_pt, 1. )   ! lateral boundary condition
 
    END SUBROUTINE sol_fet
